function [m] = bt1xx(musArr44100)
    
    fs = 44100;
    
    L = length(musArr44100);
    
    dd = 1000;
    
    z = zeros(dd+1,1);
    
    y = abs([z ; musArr44100]);
    [m,d] = lowpass(y, 4, fs, "ImpulseResponse", "iir", "Steepness",0.5);
    [m,d] = bandpass(y, [1 5], fs, "ImpulseResponse", "iir", "Steepness",0.5);
    
end

% ydec = decimate(y, 64);
% 
% [m,d] = lowpass(ydec, 4, fs/64, "ImpulseResponse", "iir", "Steepness",0.5);
% [m,d] = bandpass(y, [1 5], fs/64, "ImpulseResponse", "iir", "Steepness",[0.5 0.5]);
% 
% 
% 





% fs = 44100;
% 
% [musArr44100, ~] = audioread(['work/etyp1/mus.wav']);
% yOrg = (musArr44100(6*44100:11*44100, 1) + musArr44100(6*44100:11*44100, 2))/2;
% sound(yOrg, fs);
% 
% [musArr44100, ~] = audioread(['work/etyp1/mus.wav']);
% yOrg = (musArr44100(6*44100:11*44100, 1) + musArr44100(6*44100:11*44100, 2))/2;
% sound(yOrg, fs);
% 
% [musArr44100, ~] = audioread(['work/sambaOrg1/mus.wav']);
% yOrg = (musArr44100(8*44100:14*44100, 1) + musArr44100(8*44100:14*44100, 2))/2;
% sound(yOrg, fs);
% 
% [musArr44100, ~] = audioread(['work/pump1/mus.wav']);
% yOrg = (musArr44100(8*44100:14*44100, 1) + musArr44100(8*44100:14*44100, 2))/2;
% sound(yOrg, fs);
% 
% % Dec og bp filter
% fig1;plott(1:length(yOrg), yOrg/max(yOrg));axis tight;
% D = 200;
% ydec = decimate(abs(yOrg), D);
% fig2;plott(1:length(ydec), ydec/max(ydec));axis tight;
% [m,d] = bandpass(ydec, [2 6], fs/D, "ImpulseResponse", "iir", "Steepness",[0.7 0.7], 'StopbandAttenuation',30);
% fig3;plott(1:length(m), m/max(m));axis tight;
% 
% % glidende filt uten dec
% L = length(yOrg);
% dd = 1000;
% z = zeros(dd+1,1);
% y = abs([z ; yOrg]);
% m = zeros(size(y));
% for s = dd+1 : size(y,1)
%     diffSum = 0;
%     for d = 1 : dd
%         %v = sin((pi/2)*d/dd);
%         v = 1;
%         diffSum = diffSum + (y(s-d));
%     end
%     m(s) = diffSum;
% end
% fig3;plott(1:length(m), m/max(m));axis tight;
% 
% % manual dec
% L = length(yOrg);
% dd = 64*12; % 60hz
% z = zeros(dd+1,1);
% y = abs([z ; yOrg]);
% m = [];
% for s = dd+1 : dd : size(y,1)
%     diffSum = 0;
%     for d = 1 : dd
%         diffSum = diffSum + (y(s-d));
%     end
%     m = [m ; diffSum];
% end
% fig4;plott(1:length(m), m/max(m));axis tight;

%%%%%%%%%%%%
%{

|                     |                     |
[  uttafor    ][ inni ]...]
                      [  uttafor    ][ inni ]...]

pre: gain
para: T, ph, thr
fit:
    antTomme        telle restart uten treff                   --- senke thr
    antUttafor      telle i "uttafor" men tillate noen         --- øke tersk
    antGodTreff     vektet treff                               --- just ph T
    gjevnT          varians på T som lagres
 

%}



function [] = tt()
clear;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% stream
fs = 44100;
fsDec = fs/(64*12); % ca 57 Hz
fsChunk =fs/64; % ca 689z

[mus, ~] = audioread(['work/etyp1/mus.wav']);
stSec = 1;
enSec = 45;
yOrg = (mus(stSec*44100:enSec*fs, 1) + mus(stSec*44100:enSec*fs, 2))/2;
% fig1;plott(1:length(yOrg), yOrg);axis tight;
% sound(yOrg, fs);
LmusOrg = length(yOrg);

minTms = 200;
minTsamDec = fsDec * minTms / 1000;
maxTms = 600;
maxTsamDec = fsDec * maxTms / 1000;
yTersk = 110;
chNr = 0;
sumY = 0;
absFiltPlotArr = [];
clickPlotArr = []; % fsD
samDecTeller = 0;
funnetTsArr = [];
funnetTsDecMean = 0;
funnetTsDecAnt = 0;
oscFase = 0;      % Fs/64 sampl
oscFreq = 1/(12*25);   % Fs/64 sampl
oscSchunkTeller = 0; % Fs/64 sampl
oscPlotArr = [];      % Fs/64

for chNr_ = 1 : floor(LmusOrg/64) - 1
    yCh = yOrg(chNr_*64 : chNr_*64 + 63); % x = oscSchunkTeller
    
    %%%% yCh inn til Mxj
    
    chNr = chNr + 1; % resettes etter 12 chunks
    
    % Osc
    oscSchunkTeller = oscSchunkTeller + 1; % resettes ikke, teller fortløpende
    oscY = sin(2*pi * oscFreq * oscSchunkTeller + oscFase);
    oscYd = cos(2*pi * oscFreq * oscSchunkTeller + oscFase); % den deriverte
    oscPlotArr = [oscPlotArr ; oscY]; % IKKE MAX
    
    for i = 1 : 64
        sumY = sumY + abs(yCh(i)); % første del av 12 stk 64 summer
    end
    
    %%
    if chNr > 11 %%%%% Nedsampler her - er nå decimert, y = sumY
        
        absFiltPlotArr = [absFiltPlotArr ; sumY]; % IKKE MAX
        
        if sumY > 100 && samDecTeller > minTsamDec % Treff innafor grenser
            treff = 1;
            clickPlotArr = [clickPlotArr ; 1]; % IKKE MAX
            
            if samDecTeller < maxTsamDec % er over start transient, kommet i gang 
                funnetTsArr = [funnetTsArr ; samDecTeller]; % IKKE MAX
                
                % finner gjennmsnitt TsDec
                funnetTsDecAnt = funnetTsDecAnt + 1;
                if funnetTsDecAnt == 1
                    funnetTsDecMean = samDecTeller;
                else
                    funnetTsDecMean = (funnetTsDecMean * (funnetTsDecAnt - 1) + samDecTeller)/funnetTsDecAnt;
                end
                
            end
            samDecTeller = 0;  % resetter siden funnet edge
        else              % Ikke treff ennå
            treff = 0;
            clickPlotArr = [clickPlotArr ; 0]; % IKKE MAX
        end
        
        % Osc
        if treff == 1
            oscTs = 1/oscFreq;
            oscTs = oscTs - 0.2*(oscTs/12 - funnetTsDecMean); 
            % oscFreqOld = oscFreq;
            oscFreq = 1/oscTs;
            
            oscFase = oscFase + 0.4*oscYd;
            % fra freq
            % oscFase = oscFase - 2*pi*oscS64teller*(oscFreqOld-oscFreq);
        end
        
        %%%%%
        
        samDecTeller = samDecTeller + 1; % resettes ikke
        
        sumY = 0; % summer/vinduer over 64*12 sampler
        chNr = 0; % dec 
    end
end
fig2;plott(1:length(absFiltPlotArr), absFiltPlotArr);line([1 length(absFiltPlotArr)], [yTersk yTersk]);axis tight;
fig3;plott(1:length(clickPlotArr), clickPlotArr, 'lCol',[0 0.5 1]);axis tight;
plott([1:length(oscPlotArr)]*(1/12), oscPlotArr, 'hold');axis tight;

floor(1000*funnetTsArr(2:end)/fsDec)


% test FM

x = 1:0.01: 20;
fc = 2;
y = sin(2*pi*fc*x);
% vil at x=10 fir y = 0
% 2*pi*2.01*10 = 2*pi*2*10 
% 2*pi*2.01*10  - 2*pi*2*10 = 2*pi*10*(2.01-2)

f = 2.02;
y2 = sin(2*pi*f*x - 2*pi*10*(f-fc));

fig2;plott(x, y);axis tight;grid on;
fig3;plott(x, y2);axis tight;grid on;

end















