function [m] = bt1b(diffArr)
    
    fs = 44100;
    
    L = length(diffArr);
    
    thre = (2/3)*max(diffArr);
    
    maxTms = 600; % ms
    minTms = 200;
    
    minTsamp = fs * minTms / 1000;
    
    m = zeros(size(diffArr));
    
    teller = 0;
    for s = 1 : L
        
        teller = teller + 1;
        if diffArr(s) > thre && teller > minTsamp
            m(s) = 1;
            teller = 0;
        end
        
    end
    
end


%{

mus = (A.musArr44100(6*44100:11*44100, 1) + A.musArr44100(6*44100:11*44100, 2))/2;
fig1;plott(1:length(mus), mus);
m1 = bt1(mus);
fig2;plott(1:length(m1), m1);

m2 = bt1b(m1);
fig3;plott(1:length(m2), m2);
%}